Example: cloc/vector_copy_hip
==============================

This example shows how to use the cloc.sh script to compile hip kernels in the file vector_copy.cu
to create an HSA Code Object (hsaco) file.
The source code in vector_copy.cpp uses the HIP host API to load and launch the kernel specifically
from the file named "vector_copy.hsaco".
This file contains the GPU isa and is created by the cloc.sh utility from the source code found in "vectory_copy.cu".

To compile and run this example, execute these commands:

```
  make
  ./vector_copy
```

The Makefile will generate and execute three commands to build the vector_copy binary
and the vector_copy.hsaco file.
Depending on your environment, the generated commands will be similar to these:
```
/usr/lib/aomp/bin/clang++ -c -std=c++11 -D__HIP_PLATFORM_HCC__ -o obj/vector_copy.o vector_copy.cpp
/usr/lib/aomp/bin/clang++ obj/vector_copy.o -L/usr/lib/aomp/lib -lhip_hcc -Wl,-rpath,/usr/lib/aomp/lib -o vector_copy
/usr/lib/aomp/bin/cloc.sh -mcpu gfx900 vector_copy.cu

```
The first two commands compile and link the application source in vector_copy.cpp
to create application binary called "vector_copy".
The file "vector_copy.hsaco" was created by the cloc.sh utility in the third commmand generated by the Makefile.
The Makefile calls the utility 'mygpu' to determine which gfx processor is running.
In the above scenario, the mygpu utility chose the default value gfx900.
This value is used by cloc.sh to build an hsaco file for that GPU using the -mcpu option.
